*#=============================================================================
*# Copyright (C) 2004 RECITAL CORPORATION Inc.. 
*# As an unpublished licenced proprietary work.
*# All rights reserved worldwide.
*#=============================================================================
*	MODULE		: custproc.prg
*
*	VERSION		: Recital v9.0
*
*	PURPOSE		: Procedure Library for RECITAL demo and videos 
*
*	AUTHOR		: Recital Corporation Inc.
*
*	DATE		: 01-JUN-1993
*==============================================================================


*--------------------------------------------------------------------*
* Called from CUSTOMER.PRG which is an Open Trigger for CUSTOMER.DBF *
* Opens up the first DBX index tag for all open files.               *
*--------------------------------------------------------------------*
Procedure OpenTags 
  cAlias = alias()
  select 1
  for i = 1 to workarea() - 1
    select (i)
    set order to 1
  next
  select (cAlias)
return

*--------------------------------------------*
* Called from the SAVE menu bar of FILE menu *
*--------------------------------------------*
procedure menus
parameter menuitem

  menuitem = strtran(menuitem,".")
  if " "$menuitem
    menuitem = left(menuitem,at(" ",menuitem))
  endif
  do (menuitem)

return

*--------------------------------------------*
* Called from the SAVE menu bar of FILE menu *
*--------------------------------------------*
procedure save

  keyboard chr(ctrl('w'))

return

*--------------------------------------------*
* called from the EXIT menu bar of FILE menu *
*--------------------------------------------*
procedure exit

  keyboard chr(ctrl('g'))

return

*----------------------------------------------*
* called from the MODIFY menu bar of FILE menu *
*----------------------------------------------*
procedure modify

  select product
  save screen
  edit noclear
  restore screen
  select customer

return

*-------------------------------------------*
* called from the NEW menu bar of FILE menu *
*-------------------------------------------*
procedure new

  select product
  save screen
  append noclear
  restore screen
  select customer

return

*---------------------------------------------*
* called from the PRINT menu bar of FILE menu *
*---------------------------------------------*
procedure print

  printscreen()

return

*----------------------------------------------*
* called from the UPDATE menu bar of EDIT menu *
*----------------------------------------------*
procedure update

  if .not. set("update")
    keyboard chr(ctrl('t'))
  endif

return

*---------------------------------------------*
* called from the QUERY menu bar of EDIT menu *
*---------------------------------------------*
procedure query

  if set("update")
    keyboard chr(ctrl('t'))
  endif

return

*----------------------------------------------*
* called from the DELETE menu bar of EDIT menu *
*----------------------------------------------*
procedure delete

  if .not. delete()
    keyboard chr(ctrl('t'))+chr(ctrl('u'))
  endif

return

*----------------------------------------------*
* called from the RECALL menu bar of EDIT menu *
*----------------------------------------------*
procedure recall

  if delete()
    keyboard chr(ctrl('t'))+chr(ctrl('u'))
  endif

return

*---------------------------------------------*/
* called from the NOTES menu bar of EDIT menu */
*---------------------------------------------*/
procedure notes

  memoedit(notes,2,53,5,76,.t.)
  memosay(notes,2,53,5,76)

return

*----------------------------------------------*
* called from the FIND menu bar of SEARCH menu *
*----------------------------------------------*
procedure find

  keyboard chr(ctrl('k'))

return

*--------------------------------------------------*
* called from the FINDNEXT menu bar of SEARCH menu *
*--------------------------------------------------*
procedure findnext

  keyboard chr(ctrl('l'))

return

*---------------------------------------------------*
* called from the CALCULATOR menu bar of TOOLS menu *
*---------------------------------------------------*
procedure calculator

  save screen
  calculator bold
  restore screen

return

*----------------------------------------------*
* called from the DIARY menu bar of TOOLS menu *
*----------------------------------------------*
procedure diary

  save screen
  calendar menu schedule clear bold
  restore screen

return

*------------------------------------------------*
* called from the NOTEPAD menu bar of TOOLS menu *
*------------------------------------------------*
procedure notepad

  save screen
  memoedit("notepad.txt",4,17,19,62,.t.,"NotePad")
  restore screen

return

*------------------------------------------------------*
* called from the ORDERS form of the ACCOUNTS database *
*------------------------------------------------------*
procedure orders_prerec

  *--------------------------*
  * calculate account values *
  *--------------------------*
  do acct_values

  *------------------------------*
  * display the notes memo field *
  *------------------------------*
  memosay(notes,2,53,5,76)

return

*---------------------------------------------------*
* called from the ORDERS form of the ACCOUNTS table *
*---------------------------------------------------*
procedure order_posttrig

  *--------------------------*
  * calculate account values *
  *--------------------------*
  do acct_values
  show gets

return

*------------------------------------------------------*
* called from the ORDERS form of the ACCOUNTS database *
*------------------------------------------------------*
procedure acct_values

  *--------------------------*
  * calculate account values *
  *--------------------------*
  if empty(accounts->account_no) .or. readmode() = "APPEND"
    store 0 to m_ord_val,m_paid_val,m_balance,m_orders
  else
    m_set = set("perfmeter")
    set perfmeter off
    select accounts
    seek customer->account_no
    m_recno = recno()
    calculate rest SUM(ord_value),SUM(paid_value),SUM(balance),CNT();
              to m_ord_val,m_paid_val,m_balance,m_orders;
	      while accounts->account_no = customer->account_no
    goto m_recno
    select customer
    set perfmeter (m_set)
  endif
return

*------------------------------------------------------*
* called from the ORDERS form of the ACCOUNTS database *
*------------------------------------------------------*
procedure orderspreform

  public m_ord_val,m_paid_val,m_balance,m_orders
  store 0 to m_ord_val,m_paid_val,m_balance,m_orders
  set status on

return

*------------------------------------------------------*
* called from the ORDERS form of the ACCOUNTS database *
*------------------------------------------------------*
procedure orderspostform

  release m_ord_val,m_paid_val,m_balance,m_orders
  set status off

return

*------------------------------------*
* UDF called from customer.lbl LABEL *
*------------------------------------*
function fullname
parameter m_title,m_first_name,m_initial,m_last_name

  *-----------------------------------------------*
  * Build up a full name from the customer's name *
  *-----------------------------------------------*
  m_name = ltrim(rtrim(m_title)+" ")
  m_name = m_name + ltrim(rtrim(m_first_name)+" ")
  m_name = m_name + ltrim(rtrim(m_initial)+" ")
  m_name = m_name + rtrim(m_last_name)

return(m_name)

