
*#=============================================================================
*# Copyright (C) 1993 RECITAL CORPORATION Inc.. 
*# As an unpublished licenced proprietary work.
*# All rights reserved worldwide.
*#=============================================================================
*	MODULE		: rbrowse.prg
*	VERSION		: Recital v7.3
*	PURPOSE		: Demonstrate RECITAL'S Relational DataWindows 
*	AUTHOR		: Recital Corporation Inc.
*	DATE		: 01-JUN-1993
*==============================================================================

*----------------------------------------------------------*
* This procedure is used to define BROWSE and MEMO windows *
* for the parent table, CUSTOMER and a Relational Browse   *
* window for the child table ACCOUNTS                      *
*----------------------------------------------------------*
procedure DecWindows

  *-------------------------------------------------------------------*
  * This window will BROWSE the child table ACCOUNTS.DBF              *
  * Only ACCOUNT record related to the current customer are displayed *
  *-------------------------------------------------------------------*
  define window wRBrowse;
      from 12,1 to 21,77;
      title "Recital - Relational browse window";
      panel;
      color w+/bg;
      float;
      grow

  *-------------------------------------------------------*
  * This window will BROWSE the parent table CUSTOMER.DBF *
  *-------------------------------------------------------*
  define window wBrowse;
      from 2,0 to 10,38;
      float;
      grow
  
  *---------------------------------------------------------*
  * This window will show the memo for the current customer *
  *---------------------------------------------------------*
  define window wMemo;
      from 02,40 to 10,79;
      title "Customer Notes";
      panel;
      color w+/g, r/w, w+/rb;
      float;
      grow
return

*---------------------------------*
* Deassign default system windows *
*---------------------------------*
procedure ClearEnv
  set status on
  set window of edit to
  set window of memo to
  set window of browse to
  set window of relation to
return
  
*-----------------------------*
* Reset environment upon exit *
*-----------------------------*
procedure CleanUp

  release window wRBrowse
  release window wMemo
  release window wBrowse
  set window of relation in accounts to
  set window of memo in customer to 
  set window of browse in customer to 
  close all
  set status off

return

*------------------------------------------------------*
* This procedure is used to define BROWSE within the   *
* windows and then to start the screen                 *
*------------------------------------------------------*
procedure DispScreen

  clear screen
  save screen
  *--------------------------------------------------------*
  * Define Relational Browse window for the ACCOUNTS table *
  *--------------------------------------------------------*
  select accounts   
  set window of relation to wRBrowse;
      command browse ;
              fields ;
              ord_no:h="Order #",ord_date:h="Date",;
              ord_value:h="Order Cost",product_no:h="Code",;
              cproduct=lookup(product->descript,;
                              accounts->product_no,product);
                      :h="Product":20,;
              rec_date:h="Recv Date",paid_value,paid_date

  *-----------------------------------------*
  * Define windows types for CUSTOMER table *
  *-----------------------------------------*
  select customer
  set window of memo in customer to wMemo
  set window of browse in customer to wBrowse

  *----------------------------------------------------*
  * Now start the screen by issuing the BROWSE command *
  *----------------------------------------------------*
  browse noclear;
         fields account_no:h="Account #":r,;
                last_name:h="Last Name",first_name:h="First Name",;
                street,city,state,zip,limit,balance,available,;
                start_date,notes
 
  restore screen
 
return
    
*--------------*
* Main Program *
*--------------*
do DecWindows
do ClearEnv
use demo
do DispScreen
do CleanUp
return
