*#=============================================================================
*# Copyright (C) 1986,1987,1988,1989,1990 RECITAL CORPORATION Ltd. 
*# As an unpublished licenced proprietary work.
*# All rights reserved worldwide.
*#=============================================================================
*
*	MODULE		: assist.prg
*
*	VERSION		: Recital v7.1
*
*	PURPOSE		: Recital/assistant
*
*	AUTHOR		: Recital Corporation Inc.
*
*	DATE		: 16-oct-1987
*
*==============================================================================
set talk off
set step off
private m_history, m_safety, m_pckeys
m_pckeys  = set("pckeys")
m_history = set("hist")
m_safety  = set("safe")
m_lock    = set("lock")
set assist on
set lock on
set desc on
set echo off
set stat on
set auto on
set hist off
set esca off
set scor off
set menu on
set head on
set macr on
set dele on
set lock off
set pckeys off
set clockrate to 1
set clock on
set safe off
set instruct on

*---------------------------------------------------------------------------
* Private variables
*---------------------------------------------------------------------------
private current_file			&& currently selected database
private current_format			&& currently selected format
private scope				&& active SCOPE value
private for_expression			&& active FOR <expression>
private field_list			&& active field list
private mtotal				&& general purpose
private overwrite			&& returned by safety
private screenmap			&& status of SCREENMAP on entry
private status				&& status of STATUS on entry
private cancel				&& .t. when ESCAPE key pressed

*===========================================================================
* Main Menu
*===========================================================================
proc main
  clear menu
  @0,0
  if iscolor()
    @0,0  say repl(" ", 80) color "menus"
    @0,0  say "Assist:" color "information"
  else
    @0,0  say bold("Assist:")
  endif
  @0,8  menu "\<Setup";
        command "menu format setup quit helpfile 'help'";
	help "Create or Modify Report and Label forms, views and database structures."
  @0,14 menu "\<Modify";
    	command "menu format modify quit helpfile 'help'";
	help "Modify existing records in the database or add new records."
  @0,21 menu "\<Retrieve";
  	command "menu format retrieve quit helpfile 'help'";
	help "Commands for retrieving and presenting information."
  @0,30 menu "\<Organize";
  	command "menu format organize quit helpfile 'help'";
	help "Perform operations on the database as a whole."
  @0,39 menu "\<General";
	command "menu format general quit helpfile 'help'";
	help "Perform general file utility operations."
  @0,47 menu "\<Bridges";
	command "menu format bridges quit helpfile 'help'";
	help "Bridges to other software products."
  @0,55 menu "\<Use";
       	command "do use;@maxrow()-2,0";
	help "Select a database for further operations.";
	norefresh
  @0,59 menu "\<Help";
       	command "Help";
	help "Activate the on-line help system."
  if iscolor()
      @0,69 say ampm() color 'information'
  else 
      @0,69 say reverse(ampm()) color 'information'
  endif
return

*===========================================================================
* Main: Set Up
*===========================================================================
proc setup
  @0,0
  if iscolor()
    @0,0  say repl(" ", 80) color "menus"
    @0,0  say "Setup:" color "information"
  else
    @0,0  say bold("Setup:")
  endif
  @0,7 menu "\<Database";
	command "do database";
	help "Create or Modify a database structure."
  @0,16 menu "\<Label";
	command "do label";
	help "Create or Modify a label format."
  @0,22 menu "\<Report";
        command "do report";
	help "Create or Modify a report format."
  @0,29 menu "\<Application";
        command "do application";
	help "Create, Modify or Execute an application."
  @0,41 menu "\<View";
        command "do view";
	help "Create or Modify a view."
  @0,46 menu "\<Screen";
	command "do screen";
	help "Create or Modify a screen format."
  @0,53 menu "\<Use";
       	command "do use;@maxrow()-2,0";
	help "Select a database for further operations.";
	norefresh
  @0,57 menu "\<Help";
       	command "Help";
	help "Activate the on-line help system."
  if iscolor()
      @0,69 say ampm() color 'information'
  else 
      @0,69 say reverse(ampm()) color 'information'
  endif
return

*---------------------------------------------------------------------------
* Set up: database
*---------------------------------------------------------------------------
proc database
  if .not.set("exclusive")
    message "This command is not valid with shared databases."
    return
  endif
  close data
  current_file=""
  fname=space(14)    
  dialog get fname;
	 title "SPECIFY FILE NAME";
         label "Database name:";
         picture "ACCCCCCCCCCCC";
	 help "Enter the name of a DATABASE file or press ^C for a list."
  if readkey()=ctrl('g')
    return
  endif
  if m->fname=' '
    @maxrow()-4,0
    set message to "Select a database from the list. Use ^g to abandon."
    lastrow=min(filecount("*.dbf")+4,maxrow()-4)
    menu files like *.dbf at 1,0 to lastrow,16 label "Databases" quit trim
    fname=menuitem()
    if len(m->fname)=0
      @1,0 clear to maxrow()-4,79
      return
    endif
    had_error=.f.
    on error had_error=.t.
    *set screenmap &screenmap
    m_dcache = set("dcache")
    set dcache off
    use &fname
    modi stru 
    *set screenmap off
    set dcache (m_dcache)
    on error
    if had_error
      msg=message()
      message "&msg.. Press any key to continue."
      @1,0 clear to maxrow()-4,79
    endif
  else
    had_error=.f.
    on error had_error=.t.
    *set screenmap &screenmap
    m_dcache = set("dcache")
    set dcache off
    modify stru &fname
    set dcache (m_dcache)
    *set screenmap off
    on error
    if had_error
      msg=message()
      message "&msg.. Press any key to continue."
    endif
  endif
  close all
  current_file=upper(dbf())
  current_format=""
  set format to
return

*---------------------------------------------------------------------------
* Set up: label
*---------------------------------------------------------------------------
proc label
  if len(m->current_file)=0
    do usedbf
    if len(m->current_file)=0.or.readkey()=ctrl('g')
      return
    endif
  endif
  fname=space(14)    
  dialog get fname;
	 title "SPECIFY FILE NAME";
         label "Label name:";
         picture "ACCCCCCCCCCCC";
	 help "Enter the name of a LABEL format file or press ^C for a list."
  if readkey()=ctrl('g')
    return
  endif
  if m->fname=' '
    @maxrow()-4,0
    set message to "Select a label from the list. Use ^g to abandon."
    lastrow=min(filecount("*.lbl")+4,maxrow()-4)
    menu files like *.lbl at 1,0 to lastrow,16 label "Label formats" quit trim
    fname=menuitem()
    if len(m->fname)=0
      @1,0 clear to maxrow()-4,79
      return
    endif
    had_error=.f.
    on error had_error=.t.
    *set screenmap &screenmap
    modi label &fname
    *set screenmap off
    on error
    if had_error
      msg=message()
      message "&msg.. Press any key to continue."
    endif
  else
    had_error=.f.
    on error had_error=.t.
    *set screenmap &screenmap
    modify label &fname
    *set screenmap off
    on error
    if had_error
      msg=message()
      message "&msg.. Press any key to continue."
    endif
  endif
return

*---------------------------------------------------------------------------
* Set up: report
*---------------------------------------------------------------------------
proc report
  if len(m->current_file)=0
    do usedbf
    if len(m->current_file)=0.or.readkey()=ctrl('g')
      return
    endif
  endif
  fname=space(14)    
  dialog get fname;
	 title "SPECIFY FILE NAME";
         label "Report name:";
         picture "ACCCCCCCCCCCC";
         help "Enter the name of a REPORT format file or press ^C for a list."
  if readkey()=ctrl('g')
    return
  endif
  if m->fname=" "
    @maxrow()-4,0
    set message to "Select a report from the list. Use ^g to abandon."
    lastrow=min(filecount("*.frm")+4,maxrow()-4)
    menu files like *.frm at 1,0 to lastrow,16 label "Report formats" quit trim
    fname=menuitem()
    if len(m->fname)=0
      @1,0 clear to maxrow()-4,79
      return
    endif
    had_error=.f.
    on error had_error=.t.
    *set screenmap &screenmap
    modi repo &fname
    *set screenmap off
    on error
    if had_error
      msg=message()
      message "&msg.. Press any key to continue."
      @1,0 clear to maxrow()-4,79
    endif
  else
    had_error=.f.
    on error had_error=.t.
    *set screenmap &screenmap
    modify repo &fname
    *set screenmap off
    on error
    if had_error
      msg=message()
      message "&msg.. Press any key to continue."
      @1,0 clear to maxrow()-4,79
    endif
  endif
return

*---------------------------------------------------------------------------
* Set up: application
*---------------------------------------------------------------------------
proc application
  do while .t.
    menu format prog_menu quit helpfile 'help'
    vtype=menu()
    if m->vtype<0
      return
    endif
    fname=space(14)    
    dialog get fname;
	   title "SPECIFY FILE NAME";
           label "Application:";
           picture "ACCCCCCCCCCCC";
	   help "Enter the name of an APPLICATION or press ^C for a list."
    if readkey()=ctrl('g')
      loop
    endif
    if m->fname=' '
      if m->vtype=1
        loop
      endif
      @maxrow()-4,0
      set message to "Select an application from the list. Use ^g to abandon."
      lastrow=min(filecount("*.app")+4,maxrow()-4)
      menu files like *.app at 1,0 to lastrow,16 label "Applications" quit trim
      @1,0 clear to maxrow()-4,79
      fname=menuitem()
      if len(m->fname)=0
        loop
      endif
      if at('.',m->fname)=0
        store m->fname+'.app' to fname
      endif
    endif
    if m->vtype=0
      @maxrow()-2,0
      store trim(m->fname) to fname
      if at('.',m->fname)=0
        store m->fname+'.app' to fname
      endif
      if .not.file(m->fname)
        message "Application does not exist."
        loop
      endif      
      set message to "Executing application &fname, please wait."
      do &fname
      set echo off
      set step off
      set talk off
      *set screenmap off
      current_file=upper(dbf())
      current_format=fmt()
      clear
    else
      if at('.',m->fname)=0
        store m->fname+'.app' to fname
      endif
      had_error=.f.
      on error had_error=.t.
      modi comm &fname.
      on error
      if had_error
        msg=message()
        message "&msg.. Press any key to continue."
      endif
    endif
  enddo
return

proc prog_menu
  @0,0
  if iscolor()
    @0,0  say repl(" ", 80) color "menus"
    @0,0  say "Application:" color "information"
  else
    @0,0  say bold("Application:")
  endif
  @0,13 menu "\<Do";
	help "Execute an existing application."
  @0,16 menu "\<Create";
	help "Create a new application."
  @0,23 menu "\<Modify";
	help "Modify an existing application."
  @0,30 menu "\<Help";
       	command "Help";
	help "Activate the on-line help system."
  if iscolor()
      @0,69 say ampm() color 'information'
  else 
      @0,69 say reverse(ampm()) color 'information'
  endif
return

*---------------------------------------------------------------------------
* Set up: view
*---------------------------------------------------------------------------
proc view
  do while .t.
    menu format view_menu quit helpfile 'help'
    vtype=menu()
    if m->vtype<0
      return
    endif
    if m->vtype=3
      close databases
      select a
      current_file=""
      current_form=""
      loop
    endif
    fname=space(14)    
    dialog get fname;
	   title "SPECIFY FILE NAME";
           label "View name:";
           picture "ACCCCCCCCCCCC";
           help "Enter the name of a VIEW file or press ^C for a list."
    if readkey()=ctrl('g')
      loop
    endif
    if m->fname=' '
      if m->vtype=1
        close all
        loop
      endif
      @maxrow()-4,0
      set message to "Select a view from the list. Use ^g to abandon."
      lastrow=min(filecount("*.vue")+4,maxrow()-4)
      menu files like *.vue at 1,0 to lastrow,16 label "Views" quit trim
      @1,0 clear to maxrow()-4,79
      fname=menuitem()
      if len(m->fname)=0
        close data
        select a
        current_file=""
        current_form=""
        loop
      endif
    endif
    if m->vtype=0
      store trim(m->fname) to fname
      if at('.',m->fname)=0
        store m->fname+'.vue' to fname
      endif
      if .not.file(m->fname)
        message "View does not exist."
        loop
      endif      
      @maxrow()-4,0
      set message to "Establishing view &fname, please wait."
      had_error=.f.
      on error had_error=.t.
      set view to &fname
      on error
      if had_error
        msg=message()
        message "&msg.. Press any key to continue."
        close all
      endif
      current_file=upper(dbf())
      current_format=fmt()
      set format to
    else
      if m->vtype=1
        do safety with "&fname",".vue"
        if .not.overwrite
          loop
        endif
        had_error=.f.
        on error had_error=.t.
        *set screenmap &screenmap
        create view &fname
        *set screenmap off
        on error
        if had_error
	  msg=message()
	  message "&msg.. Press any key to continue."
        endif
      else
        had_error=.f.
        on error had_error=.t.
        *set screenmap &screenmap
        modify view &fname
        *set screenmap off
        on error
        if had_error
	  msg=message()
	  message "&msg.. Press any key to continue."
        endif
      endif
    endif
  enddo
return

proc view_menu
  @0,0
  if iscolor()
    @0,0  say repl(" ", 80) color "menus"
    @0,0  say "View:" color "information"
  else
    @0,0  say bold("View:")
  endif
  @0,6  menu "\<Select";
	help "Establish an existing view."
  @0,13 menu "\<Create";
	help "Create a new view."
  @0,20 menu "\<Modify";
	help "Modify an existing view."
  @0,27 menu "\<Deselect";
	help "Deselect the current view."
  @0,36 menu "\<Help";
       	command "Help";
	help "Activate the on-line help system."
  if iscolor()
      @0,69 say ampm() color 'information'
  else 
      @0,69 say reverse(ampm()) color 'information'
  endif
return

*---------------------------------------------------------------------------
* Set up: screen
*---------------------------------------------------------------------------
proc screen
  do while .t.
    menu format screen_menu quit helpfile 'help'
    vtype=menu()
    if m->vtype<0
      return
    endif
    if m->vtype=3
      set format to
      store "" to current_format
      loop
    endif
    fname=space(14)    
    dialog get fname;
	   title "SPECIFY FILE NAME";
           label "Screen name:";
           picture "ACCCCCCCCCCCC";
           help "Enter the name of a SCREEN format file or press ^C for a list."
    if readkey()=ctrl('g')
      loop
    endif
    if m->fname=' '
      if m->vtype=1
        loop
      endif
      if m->vtype=0
        title="Formats"
        ftype=".fmt"
      else
        title="Screens"
        ftype=".scr"
      endif
      @maxrow()-4,0
      set message to "Select a screen from the list. Use ^g to abandon."
      lastrow=min(filecount("*&ftype")+4,maxrow()-4)
      menu files like *&ftype at 1,0 to lastrow,16 label "&title" quit trim
      @1,0 clear to maxrow()-4,79
      fname=menuitem()
      if len(m->fname)=0
        set format to
        current_format=""
        loop
      endif
    endif
    if m->vtype=0
      store trim(m->fname) to fname
      if at('.',m->fname)=0
        store m->fname+'.fmt' to fname
      endif
      store m->fname to current_format
      if .not. file("&current_format")
        message "Screen format file does not exist."
      endif
    else
      if m->vtype=1
        do safety with "&fname",".scr"
        if .not.overwrite
          loop
        endif
        had_error=.f.
        on error had_error=.t.
        create screen &fname
        on error
        if had_error
	  msg=message()
	  message "&msg.. Press any key to continue."
        endif
      else
        had_error=.f.
        on error had_error=.t.
        modify screen &fname
        on error
        if had_error
	  msg=message()
	  message "&msg.. Press any key to continue."
        endif
      endif
      current_file=""
      current_format=fmt()
      set format to
    endif
  enddo
return

proc screen_menu
  @0,0
  if iscolor()
    @0,0  say repl(" ", 80) color "menus"
    @0,0  say "Screen:" color "information"
  else
    @0,0  say bold("Screen:")
  endif
  @0,8  menu "\<Select";
	help "Select a screen format for further operations."
  @0,15 menu "\<Create";
	help "Create a new screen format."
  @0,22 menu "\<Modify";
	help "Modify an existing screen format."
  @0,29 menu "\<Deselect";
	help "Deselect the current screen format."
  @0,38 menu "\<Help";
       	command "Help";
	help "Activate the on-line help system."
  if iscolor()
      @0,69 say ampm() color 'information'
  else 
      @0,69 say reverse(ampm()) color 'information'
  endif
return

*===========================================================================
* Main: Modify
*===========================================================================
proc modify
  @0,0
  if iscolor()
    @0,0  say repl(" ", 80) color "menus"
    @0,0  say "Modify:" color "information"
  else
    @0,0  say bold("Modify:")
  endif
  @0,8  menu "\<Append";
	command "do append";
	help "Use a form to add new records to the database."
  @0,15 menu "\<Browse";
	command "do browse";
	help "Full screen browse of records in the database."
  @0,22 menu "\<Change";
	command "do change";
	help "Use a form to change records in the database."
  @0,29 menu "\<Replace";
        command "do replace";
	help "Change records in the database.";
	norefresh
  @0,37 menu "\<Query";
	command "do query";
	help "Use a form to query records in the database."
  @0,43 menu "\<Position";
	command "do position";
	help "Position to a specific record in the database.";
	norefresh
  @0,52 menu "\<Delete";
       	command "do delete";
	help "Delete records in the database.";
	norefresh
  @0,59 menu "\<Use";
       	command "do use;@maxrow()-2,0";
	help "Select a database for further operations.";
	norefresh
  @0,63 menu "\<Help";
       	command "Help";
	help "Activate the on-line help system."
  if iscolor()
      @0,69 say ampm() color 'information'
  else 
      @0,69 say reverse(ampm()) color 'information'
  endif
return

*---------------------------------------------------------------------------
* Modify: Append
*---------------------------------------------------------------------------
proc append
  if len(m->current_file)=0
    do use
    if len(m->current_file)=0.or.readkey()=ctrl('g')
      return
    endif
  endif
  set format to &current_format
  set help on
  had_error=.f.
  on error had_error=.t.
  *set screenmap &screenmap
  append
  *set screenmap off
  on error
  set help off
  if had_error
    msg=message()
    message "Error in form: &msg"
    clear
  endif
  set format to
return

*---------------------------------------------------------------------------
* Modify: Browse
*---------------------------------------------------------------------------
proc browse
  if len(m->current_file)=0
    do use
    if len(m->current_file)=0.or.readkey()=ctrl('g')
      return
    endif
  endif
  if ""#bridge()
    message "This facility is not available with bridges."
    return
  endif
  *------Browse query menu
  menu query command "BROWSE FOR " quit
  if readkey()=ctrl('g')
    @1,0 clear to maxrow()-2,79
    return
  endif
  for_expression=menuitem()
  set filter to &for_expression
  if ""=for_expression
    menu command "BROWSE"
  endif
  set query on
  if len(for_expression)#0
    set message to "Retrieving records. Please wait."
  endif
  had_error=.f.
  on error had_error=.t.
  *set screenmap &screenmap
  @maxrow()-4,0
  set relation on
  set format to &current_format
  goto top
  set lock off
  browse 
  set lock (m_lock)
  *set screenmap off
  on error
  if had_error
    msg=message()
    message "Execution error: &msg"
    clear
  endif
  set filter to
  set format to
  clear
return

*---------------------------------------------------------------------------
* Modify: Change
*---------------------------------------------------------------------------
proc change
  if len(m->current_file)=0
    do use
    if len(m->current_file)=0.or.readkey()=ctrl('g')
      return
    endif
  endif
  *------Edit query menu
  menu query command "CHANGE FOR " quit
  if readkey()=ctrl('g')
    @1,0 clear to maxrow()-2,79
    return
  endif
  for_expression=menuitem()
  set filter to &for_expression
  if ""=for_expression
    menu command "CHANGE"
  endif
  set query on
  if len(for_expression)#0
    set message to "Retrieving records. Please wait."
  endif
  set format to &current_format
  had_error=.f.
  on error had_error=.t.
  set help on
  *set screenmap &screenmap
  set lock off
  change 
  set lock (m_lock)
  *set screenmap off
  on error
  set help off
  if had_error
    msg=message()
    message "Error in form: &msg"
    clear
  endif
  set format to 
  set filter to
  clear
return

*---------------------------------------------------------------------------
* Modify: Query
*---------------------------------------------------------------------------
proc query
  if len(m->current_file)=0
    do use
    if len(m->current_file)=0.or.readkey()=ctrl('g')
      return
    endif
  endif
  *------Edit query menu
  menu query command "QUERY FOR " quit
  if readkey()=ctrl('g')
    @1,0 clear to maxrow()-2,79
    return
  endif
  for_expression=menuitem()
  set filter to &for_expression
  if ""=for_expression
    menu command "QUERY"
  endif
  if len(for_expression)#0
    set message to "Retrieving records. Please wait."
  endif
  set format to &current_format
  had_error=.f.
  set help on
  on error had_error=.t.
  *set screenmap &screenmap
  query 
  *set screenmap off
  on error
  set help off
  if had_error
    msg=message()
    message "Error in form: &msg"
    clear
  endif
  set format to
  set filter to
  clear
return

*---------------------------------------------------------------------------
* Modify: Replace
*---------------------------------------------------------------------------
proc replace
  *------If no database in use select a one using pop-up menu
  if len(m->current_file)=0
    do use
    if len(m->current_file)=0.or.readkey()=ctrl('g')
      return
    endif
  endif
  menu command "REPLACE"
  *------Replace scope menu
  menu scope at 1,0 to 10,33 quit
  if readkey()=ctrl('g')
    @1,0 clear to maxrow()-2,79
    return
  endif
  scope=menuitem()
  if ""#scope
    scope=scope+" "
  endif
  rep_list=""
  menu command "REPLACE &scope"
  *------Replace field menu
  lastrow=min(fcount()+6,maxrow()-4)
  menu fields at 1,36 to lastrow,62 label "field to replace" quit
  if readkey()=ctrl('g')
    @1,0 clear to maxrow()-2,79
    return
  endif
  field_list=menuitem()
  if len(field_list)=0
    @1,0 clear to maxrow()-2,79
    return
  endif
  menu command [REPLACE &scope.&field_list WITH]
  *------Replace value/expression to replace
  fval=type(m->field_list)
  do while .t.
    value=space(40)
    dialog get value;
	   title "SPECIFY NEW VALUE";
           pict "CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC";
           help "Enter a value or expression to REPLACE the field with.";
           label "Enter value:"
    if m->value=" ".or.readkey()=ctrl('g')
      @1,0 clear to maxrow()-2,79
      return
    endif
    if fval="C"
      if type(m->value)="U"
        store '"' + trim(m->value) +'"' to value
      endif
    endif
    if fval="D"
      xtype=type(m->value)
      if xtype="U".or.xtype="N"
        store "ctod('" + trim(m->value) + "')" to value
      endif
    endif
    set message to
    if type(m->value)#fval
      message "Invalid expression, press any key to continue."
      set message to
      loop
    endif
    clear gets
    exit
  enddo
  rep_list=field_list+" WITH "+trim(m->value)
  menu command [REPLACE &scope.&rep_list]
  *------Replace query menu
  @1,0 clear to maxrow()-4,79
  if ""#scope.and.scope#"RECORD"
    menu query command [REPLACE &scope.&rep_list FOR ] quit
    if readkey()=ctrl('g')
      @1,0 clear to maxrow()-2,79
      return
    endif
    @1,0 clear to maxrow()-4,79
    for_expression=menuitem()
    set filter to &for_expression
  else
    menu command [REPLACE &scope.&rep_list ]
  endif
  set message to "Replace in progress, please wait."
  *------Replace evaluation
  *set screenmap &screenmap
  set scroll 2,maxrow()-4
  @maxrow()-5,0
  set time on
  on error set time off
  set talk on
  replace &scope &rep_list
  set talk off
  on error
  if .not.set("time")
    message "Error in command. Press any key to continue."
  else
    set time off
    message "Replace complete, press any key to continue."
  endif
  set filter to
  set scroll 0,maxrow()
  @maxrow()-5,0 clear to maxrow()-2,79
  *set screenmap off
  @maxrow()-2,0
return

*---------------------------------------------------------------------------
* Modify: Delete
*---------------------------------------------------------------------------
proc delete
  *------If no database in use select a one using pop-up menu
  if len(m->current_file)=0
    do use 
    if len(m->current_file)=0.or.readkey()=ctrl('g')
      return
    endif
  endif
  menu command "DELETE"
  *------Delete scope menu
  menu scope at 1,0 to 10,33 quit
  if readkey()=ctrl('g')
    @1,0 clear to maxrow()-2,79
    return
  endif
  @1,0 clear to maxrow()-4,79
  scope=menuitem()
  if ""#scope
    scope=scope+" "
  endif
  menu command "DELETE &scope"
  *------Delete query menu
  menu query command "DELETE &scope.FOR " quit
  if readkey()=ctrl('g')
    @1,0 clear to maxrow()-2,79
    return
  endif
  @1,0 clear to maxrow()-4,79
  for_expression=menuitem()
  set filter to &for_expression
  set message to "Delete in progress, please wait."
  *------Delete execution
  *set screenmap &screenmap
  set scroll 2,maxrow()-4
  @maxrow()-5,0
  set talk on
  set time on
  on error set time off
  delete &scope
  set talk off
  if .not. set("time")
    msg=message()
    message "&msg.. Press any key to continue."
  else
    set time off
    set message to
    message "Delete complete, press any key to continue."
  endif
  set filter to
  set scroll 0,maxrow()
  @maxrow()-5,0 clear to maxrow()-2,79
  *set screenmap off
  @maxrow()-2,0
return

*===========================================================================
* Main: Retrieve
*===========================================================================
proc retrieve
  @0,0
  if iscolor()
    @0,0  say repl(" ", 80) color "menus"
    @0,0  say "Retrieve:" color "information"
  else
    @0,0  say bold("Retrieve:")
  endif
  @0,10 menu "\<Position";
	command "do position";
	help "Position to a specific record in the database.";
	norefresh
  @0,19 menu "\<Display";
	command "do display";
	help "Display record contents.";
	norefresh
  @0,27 menu "\<Sum";
	command "do sum";
	help "Calculate Sum of fields in records.";
	norefresh
  @0,31 menu "\<Average";
	command "do average";
	help "Calculate Average of fields in records.";
	norefresh
  @0,39 menu "\<Count";
	command "do count";
        help "Count records which satisfy a certain condition.";
	norefresh
  @0,45 menu "\<Report";
	command "do rreport";
	help "Execute saved Report format."
  @0,52 menu "\<Label";
	command "do rlabel";
	help "Generate mailing labels.";
	norefresh
  @0,58 menu "\<Use";
       	command "do use;@maxrow()-2,0";
	help "Select a database for further operations.";
	norefresh
  @0,62 menu "\<Help";
       	command "Help";
	help "Activate the on-line help system."
  if iscolor()
      @0,69 say ampm() color 'information'
  else 
      @0,69 say reverse(ampm()) color 'information'
  endif
return

*---------------------------------------------------------------------------
* Retrieve: Position
*---------------------------------------------------------------------------
proc position
  *------If no database in use select a one using pop-up menu
  if len(m->current_file)=0
    do use 
    if len(m->current_file)=0.or.readkey()=ctrl('g')
      return
    endif
  endif
  if ""#ndx(1)
    menu command "FIND"
    key=space(30)
    dialog get key;
	   title "FIND RECORD";
           label "Key to find:";
	   help "Enter the index key of the record to FIND."
    if m->key=" "
      set message to
      @maxrow()-2,0
      return
    endif
    key=trim(key)
    menu command [FIND &key]
    @maxrow()-4,0
    set message to "Searching for '&key'. Please wait."
    find &key
    if .not.found()
      message "Record not found, press any key to continue."
      @maxrow()-2,0
      return
    endif    
  else
    menu command "GOTO"
    rec=space(8)
    dialog get rec;
	   title "GOTO RECORD";
           label "Record number:";
	   picture "99999999";
	   help "Enter the record number to GOTO."
    if m->rec=" "
      @maxrow()-2,0
      return
    endif
    menu command "GOTO &rec"
    @maxrow()-4,0
    rec=val(rec)
    if m->rec>reccount().or.m->rec<=0
      message "Record is out of range, press any key to continue."
      @maxrow()-2,0
      return
    endif    
    goto &rec
  endif
  @maxrow()-2,0
return

*---------------------------------------------------------------------------
* Retrieve: Display
*---------------------------------------------------------------------------
proc display
  *------If no database in use select a one using pop-up menu
  if len(m->current_file)=0
    do use
    if len(m->current_file)=0.or.readkey()=ctrl('g')
      return
    endif
  endif
  menu command "DISPLAY"
  *------Display fields menu
  lastrow=min(fcount()+6,maxrow()-4)
  menu skip fields at 1,0 to lastrow,26;
       select ",";
       command "DISPLAY " quit
  if readkey()=ctrl('g')
    @1,0 clear to maxrow()-2,79
    return
  endif
  @1,0 clear to maxrow()-4,79
  field_list=menuitem()
  if len(m->field_list)#0
    flist = field_list + " "
  else
    flist = ""
  endif
  *------Display query menu
  menu query command "DISPLAY &flist.FOR " quit
  if readkey()=ctrl('g')
    @1,0 clear to maxrow()-2,79
    return
  endif
  @1,0 clear to maxrow()-4,79
  for_expression=menuitem()
  set filter to &for_expression
  if ""=for_expression
    menu command "DISPLAY &flist"
  endif
  *------Display evaluation
  *set screenmap &screenmap
  if len(for_expression)#0
    set message to "Retrieving records. Please wait."
    @maxrow(),0 say ""
  endif
  goto top
  if len(flist)#0
    declare fieldnames[fcount()]
    astore(fieldnames, flist, ',')
    for i=1 to alen(fieldnames)
      fieldnames[i] = proper(fieldnames[i])
    next
    if len(for_expression)#0
      menu command "DISPLAY &flist.FOR &for_expression"
    else
      menu command "DISPLAY &flist."
    endif
    set message to;
	"Navigate with UP, DOWN, LEFT, RIGHT, ^N, and ^R. Press ^W to exit."
    if ""#bridge()
      set scroll 3,maxrow()-4
      @2,0
      display all &flist assist off
      set scroll 0,maxrow()
    else 
      dbedit(1, 0, maxrow()-3, 79, fieldnames)
    endif
    release fieldnames
  else
    set message to;
	"Navigate with UP, DOWN, LEFT, RIGHT, ^N, and ^R. Press ^W to exit."
    if len(for_expression)#0
      menu command "DISPLAY &flist.FOR &for_expression"
    else
      menu command "DISPLAY &flist."
    endif
    if ""#bridge()
      set scroll 3,maxrow()-4
      @2,0
      display all &flist assist off
      set scroll 0,maxrow()
    else 
      dbedit(1, 0, maxrow()-3, 79)
    endif
  endif
  set message to
  @1,0 clear to maxrow()-2,79
  set filter to
  *set screenmap off
return

*---------------------------------------------------------------------------
* Retrieve: Sum
*---------------------------------------------------------------------------
proc sum
  *------If no database in use select a one using pop-up menu
  if len(m->current_file)=0
    do use
    if len(m->current_file)=0.or.readkey()=ctrl('g')
      return
    endif
  endif
  menu command "SUM"
  *------Sum fields menu
  lastrow=min(nfcount()+6,maxrow()-4)
  menu numeric fields @1,0 to lastrow,26 label "Numeric fields" quit
  if readkey()=ctrl('g')
    @1,0 clear to maxrow()-2,79
    return
  endif
  @1,0 clear to maxrow()-4,79
  field_list=menuitem()
  if len(field_list)=0
    @maxrow()-2,0
    return
  endif
  *------Sum query menu
  menu query command "SUM &field_list FOR " quit
  if readkey()=ctrl('g')
    @1,0 clear to maxrow()-2,79
    return
  endif
  @1,0 clear to maxrow()-4,79
  for_expression=menuitem()
  set filter to &for_expression
  if ""=for_expression
    menu command "SUM &field_list"
  endif
  set message to "Sum in progress, please wait."
  *------Sum evaluation
  *set screenmap &screenmap
  set scroll 2,maxrow()-4
  @maxrow()-5,0
  set talk on
  sum &field_list to mtotal
  set talk off
  set message to
  message "Sum of &field_list is &mtotal, press any key to continue."
  set filter to
  set scroll 0,maxrow()
  @maxrow()-5,0 clear to maxrow()-2,79
  *set screenmap off
  @maxrow()-2,0
return

*---------------------------------------------------------------------------
* Retrieve: Average
*---------------------------------------------------------------------------
proc average
  *------If no database in use select a one using pop-up menu
  if len(m->current_file)=0
    do use
    if len(m->current_file)=0.or.readkey()=ctrl('g')
      return
    endif
  endif
  menu command "AVERAGE"
  *------Average fields menu
  lastrow=min(nfcount()+6,maxrow()-4)
  menu numeric fields at 1,0 to lastrow,26 label "Numeric fields" quit
  if readkey()=ctrl('g')
    @1,0 clear to maxrow()-2,79
    return
  endif
  @1,0 clear to maxrow()-4,79
  field_list=menuitem()
  if len(field_list)=0
    @maxrow()-2,0
    return
  endif
  *------Average query menu
  menu query command "AVERAGE &field_list FOR " quit
  if readkey()=ctrl('g')
    @1,0 clear to maxrow()-2,79
    return
  endif
  @1,0 clear to maxrow()-4,79
  for_expression=menuitem()
  set filter to &for_expression
  if ""=for_expression
    menu command "AVERAGE &field_list"
  endif
  set message to "Average in progress, please wait."
  *------Average evaluation
  *set screenmap &screenmap
  set scroll 2,maxrow()-4
  @maxrow()-5,0
  set talk on
  average &field_list to mtotal
  set talk off
  set message to
  message "Average &field_list is &mtotal, press any key to continue."
  set filter to
  set scroll 0,maxrow()
  @maxrow()-5,0 clear to maxrow()-2,79
  *set screenmap off
  @maxrow()-2,0
return

*---------------------------------------------------------------------------
* Retrieve: Count
*---------------------------------------------------------------------------
proc count
  *------If no database in use select a one using pop-up menu
  if len(m->current_file)=0
    do use 
    if len(m->current_file)=0.or.readkey()=ctrl('g')
      return
    endif
  endif
  menu command "COUNT"
  *------Count query menu
  menu query command "COUNT FOR " quit
  if readkey()=ctrl('g')
    @1,0 clear to maxrow()-2,79
    return
  endif
  @1,0 clear to maxrow()-4,79
  for_expression=menuitem()
  set filter to &for_expression
  if ""=for_expression
    menu command "COUNT"
  endif
  set message to "Count in progress, please wait."
  *------Count evaluation
  *set screenmap &screenmap
  set scroll 2,maxrow()-4
  @maxrow()-5,0
  set talk on
  count to mtotal
  set talk off
  set message to
  message "Count is &mtotal, press any key to continue."
  set filter to
  set scroll 0,maxrow()
  @maxrow()-5,0 clear to maxrow()-2,79
  *set screenmap off
  @maxrow()-2,0
return

*---------------------------------------------------------------------------
* Retrieve: Report
*---------------------------------------------------------------------------
proc rreport
  *------If no database in use select a one using pop-up menu
  if len(m->current_file)=0
    do use 
    if len(m->current_file)=0.or.readkey()=ctrl('g')
      return
    endif
  endif
  menu command "REPORT"
  *------Report files menu
  set message to "Select a report from the list. Use ^g to abandon."
  lastrow=min(filecount("*.frm")+4,maxrow()-4)
  menu files like *.frm at 1,0 to lastrow,16 label "Report formats" quit trim
  form_name=menuitem()
  if len(m->form_name)=0
    @1,0 clear to maxrow()-2,79
    return
  endif
  *------Report scope menu
  menu command "REPORT FORM &form_name"
  menu scope at 1,18 to 10,51 quit
  if readkey()=ctrl('g')
    @1,0 clear to maxrow()-2,79
    return
  endif
  scope=menuitem()
  if ""#scope
    scope=scope+" "
  endif
  menu command "REPORT FORM &form_name &scope"
  *------Report destination menu
  menu frame at 1,53 to 8,65 label "Destination"
  @4,54 menu "\<terminal   " help "Display the REPORT on the screen."
  @5,54 menu "\<file       " help "Generate REPORT into a FILE."
  @6,54 menu "\<sysprint   " help "Send REPORT to the system printer."
  @7,54 menu "\<print      " help "Send REPORT to the slave printer."
  menu quit
  if len(menuitem())=0
    @1,0 clear to maxrow()-2,79
    return
  endif
  dest=menuitem()
  if dest="file"
    menu command "REPORT FORM &form_name &scope.TO FILE "
    fname=space(14)
    dialog get fname;
	   title "SPECIFY A FILE NAME";
           label "Filename:";
	   picture "ACCCCCCCCCCCCC";
	   help "Enter the name of the destination file to REPORT into."
    if m->fname=" "
      @1,0 clear to maxrow()-2,79
      return
    endif
    fname=trim(m->fname)
    whereto="TO FILE &fname"
    rep_to="TO FILE &fname"
  else
    if dest="sysprint"
      menu command "REPORT FORM &form_name &scope.TO PRINT"
      whereto=""
      rep_to="TO PRINT"
    else
      if dest="print"
        menu command "REPORT FORM &form_name &scope.TO PRINT"
        whereto="TO PRINT"
        rep_to="TO PRINT"
      else
        menu command "REPORT FORM &form_name &scope.TO TERMINAL"
        whereto="TO TERMINAL CLEAR"    
        rep_to="TO TERMINAL"
      endif
    endif
  endif
  *------Report query menu       
  @1,0 clear to maxrow()-4,79
  menu query command "REPORT FORM &form_name &scope.&rep_to FOR " quit
  if readkey()=ctrl('g')
    @1,0 clear to maxrow()-2,79
    return
  endif
  @1,0 clear to maxrow()-4,79
  for_expression=menuitem()
  set filter to &for_expression
  if ""=for_expression
    menu command "REPORT FORM &form_name &scope.&rep_to"
  endif
  *------Generate report
  set message to "Generating report, please wait."
  if dest="sysprint"
    n=str(getpid(),8,0,16)
    n=ltrim(n)
    whereto=""
    set alternate to &n..tmp
    set console off
  endif
  had_error=.f.
  on error had_error=.t.
  *set screenmap &screenmap
  report form &form_name &scope &whereto underline
  *set screenmap off
  on error
  set console on
  if had_error
    set message to
    msg=message()
    message "&msg.. Press any key to continue."
    clear
    set filter to
    return
  endif
  if dest="sysprint"
    set message to
    message "Report complete, press any key to continue."
    close alternate to print
  else
    if dest="terminal"
      clear
    endif    
  endif
  set filter to
return

*---------------------------------------------------------------------------
* Retrieve: Label
*---------------------------------------------------------------------------
proc rlabel
  *------If no database in use select a one using pop-up menu
  if len(m->current_file)=0
    do use 
    if len(m->current_file)=0.or.readkey()=ctrl('g')
      return
    endif
  endif
  menu command "LABEL"
  *------Label files menu
  set message to "Select a label format from the list. Use ^g to abandon."
  lastrow=min(filecount("*.lbl")+4,maxrow()-4)
  menu files like *.lbl at 1,0 to lastrow,16 label "Label formats" quit trim
  form_name=menuitem()
  if len(m->form_name)=0
    @1,0 clear to maxrow()-2,79
    return
  endif
  *------Label scope menu
  menu command "LABEL FORM &form_name"
  menu scope at 1,18 to 10,51 quit
  if readkey()=ctrl('g')
    @1,0 clear to maxrow()-2,79
    return
  endif
  scope=menuitem()
  if ""#scope
    scope=scope+" "
  endif
  menu command "LABEL FORM &form_name &scope"
  *------Label destination menu
  menu frame at 1,53 to 8,65 label "Destination"
  @4,54 menu "\<terminal   " help "Display the labels on the screen."
  @5,54 menu "\<file       " help "Generate the labels into a FILE."
  @6,54 menu "\<sysprint   " help "Print the labels on the system printer."
  @7,54 menu "\<print      " help "Print the labels on the slave printer."
  menu quit
  if len(menuitem())=0
    @1,0 clear to maxrow()-2,79
    return
  endif
  dest=upper(menuitem())
  if dest="FILE"
    menu command "LABEL FORM &form_name &scope.TO FILE "
    fname=space(14)
    dialog get fname;
	   title "SPECIFY A FILE NAME";
           label "Filename:";
	   picture "ACCCCCCCCCCCCC";
	   help "Enter the name of the destination file to LABEL into."
    if m->fname=' '
      @1,0 clear to maxrow()-2,79
      return
    endif
    fname=trim(m->fname)
    whereto="TO FILE &fname"
    rep_to="TO FILE &fname "
  else
    if dest="PRINT"
      menu command "LABEL FORM &form_name &scope.TO PRINT"
      whereto="TO PRINT"
      rep_to="TO PRINT "
    else
      if dest="SYSPRINT"
        menu command "LABEL FORM &form_name &scope"
        whereto=""
        rep_to="TO PRINT "
      else
        menu command "LABEL FORM &form_name &scope"
        whereto=""
        rep_to=""
      endif
    endif
  endif
  *------Label query menu       
  @1,0 clear to maxrow()-4,79
  menu query command "LABEL FORM &form_name &scope.&rep_to.FOR " quit
  if readkey()=ctrl('g')
    @1,0 clear to maxrow()-2,79
    return
  endif
  @1,0 clear to maxrow()-4,79
  for_expression=menuitem()
  set filter to &for_expression
  if ""=for_expression
    menu command "LABEL FORM &form_name &scope.&rep_to"
  endif
  *------Generate labels
  set message to "Generating labels, please wait."
  if dest="SYSPRINT"
    n=str(getpid(),8,0,16)
    n=ltrim(n)
    whereto=""
    set alternate to &n..tmp
    set console off
  endif
  *set screenmap &screenmap
  set scroll 2,maxrow()-4
  @2,0
  had_error=.f.
  on error had_error=.t.
  label form &form_name &scope &whereto
  on error
  set console on
  if had_error
    set message to
    msg=message()
    message "&msg.. Press any key to continue."
  endif
  if dest="SYSPRINT"
    close alternate to print
  else
    if dest="TERMINAL".and..not.had_error
      set message to
      message "Label generation complete, press any key to continue."
    endif    
  endif
  set filter to
  set scroll 0,maxrow()
  @1,0 clear to maxrow()-2,79
  *set screenmap off
  @1,0 clear to maxrow()-2,79
return

*===========================================================================
* Main: Organize
*===========================================================================
proc organize
  @0,0
  if iscolor()
    @0,0  say repl(" ", 80) color "menus"
    @0,0  say "Organize:" color "information"
  else
    @0,0  say bold("Organize:")
  endif
  @0,10 menu "\<Index";
	command "do Index";
	help "Create an index file for the currently selected database.";
	norefresh
  @0,16 menu "\<Reindex";
	command "do reindex";
	help "Recreate current index files for the currently selected database.";
	norefresh
  @0,24 menu "\<Sort";
	command "do sort";
	help "Sort records into Ascending or Descending order.";
	norefresh
  @0,29 menu "\<Copy";
	command "do copy with []";
	help "Copy records from one database to another.";
	norefresh
  @0,34 menu "\<Pack";
        command "do pack";
	help "Remove records which are marked for deletion.";
	norefresh
  @0,39 menu "\<Zap";
	command "do zap";
	help "Delete all records and Pack database.";
	norefresh
  @0,43 menu "\<Append";
	command "do appendfrom with [],[dbf],[Database]";
	help "Append records from another database.";
	norefresh
  @0,50 menu "\<Total";
	command "do total";
	help "Summarize and total numeric fields to another database.";
	norefresh
  @0,56 menu "\<Use";
       	command "do use;@maxrow()-2,0";
	help "Select a database for further operations.";
	norefresh
  @0,60 menu "\<Help";
       	command "Help";
	help "Activate the on-line help system."
  if iscolor()
      @0,69 say ampm() color 'information'
  else 
      @0,69 say reverse(ampm()) color 'information'
  endif
return

*---------------------------------------------------------------------------
* Organise: Index
*---------------------------------------------------------------------------
proc index
  offset=0
  if len(m->current_file)=0
    set message to "Select a database from the list. Use ^g to abandon."
    lastrow=min(filecount("*.dbf")+4,maxrow()-4)
    menu files like *.dbf at 1,0 to lastrow,16 label "Databases" quit trim
    current_format=""
    current_file=menuitem()
    access=.t.
    on error access=.f.
    use &current_file
    on error
    if .not.m->access
      current_format=""
      current_file=""
      set message to
      message "You have no permission to access this database."
    endif
    current_format=fmt()
    set format to
    if len(current_file)=0
      @1,0 clear to maxrow()-2,79
      return
    endif
    offset=18
  endif
  if ""#bridge()
    message "This facility is not available with bridges."
    @1,0 clear to maxrow()-2,79
    return
  endif
  menu command "INDEX ON "
  lastrow=min(fcount()+6,maxrow()-4)
  menu index fields at 1,0+offset to lastrow,26+offset;
       command "INDEX ON " select "+" quit
  field_list=menuitem()
  if len(field_list)=0.or.readkey()=ctrl('g')
    @1,0 clear to maxrow()-2,79
    return
  endif
  menu command "INDEX ON &field_list TO"
  fname=space(14)
  dialog get fname;
	 title "SPECIFY FILE NAME";
         label "Filename:";
         picture "ACCCCCCCCCCCCC";
	 help "Enter the name of the destination file to INDEX into."
  if m->fname=' '
    @1,0 clear to maxrow()-2,79
    return
  endif
  menu command "INDEX ON &field_list TO &fname"
  @1,0 clear to maxrow()-4,79
  *set screenmap &screenmap
  set scroll 2,maxrow()-4
  set message to "Index in progress, please wait."
  set talk on
  set time on
  on error set time off
  index on &field_list to &fname
  set talk off
  on error
  set message to 
  if .not.set("time")
    msg=message()
    message "&msg.. Press any key to continue."
  else
    set time off
    message "Index complete, press any key to continue."
  endif
  set scroll 0,maxrow()
  @17,0 clear to maxrow()-2,79
  *set screenmap off
  @maxrow()-2,0
return

*---------------------------------------------------------------------------
* Organise: Reindex
*---------------------------------------------------------------------------
proc reindex
  if .not.set("exclusive")
    message "This command is not valid with shared databases."
    return
  endif
  dirty=.f.
  offset=0
  lastrow=maxrow()-4
  if len(m->current_file)=0
    set message to "Select a database from the list. Use ^g to abandon."
    lastrow=min(filecount("*.dbf")+4,maxrow()-4)
    menu files like *.dbf at 1,0 to lastrow,16 label "Databases" quit trim
    current_format=""
    current_file=menuitem()
    access=.t.
    on error access=.f.
    use &current_file
    on error
    if .not.m->access
      current_file=""
      msg=message()
      message "&msg.. Press any key to continue."
    endif
    current_format=fmt()
    set format to
    if len(m->current_file)=0
      @1,0 clear to maxrow()-2,79
      return
    endif
    dirty=.t.
    offset=18
  endif
  if ""#bridge()
    message "This facility is not available with bridges."
    if dirty
      @1,0 clear to maxrow()-2,79
    endif
    return
  endif
  if ""=ndx(1)
    lastrow=min(ifilecount("*.ndx")+4,maxrow()-4)
    set message to "Select an index file from the list. Use ^g to abandon."
    menu index files like *.ndx at 1,offset to lastrow,offset+16;
         select ",";
	 label "Indexes" quit trim
    idx=menuitem()
    set index to &idx  
    if ""=ndx(1)
      @1,0 clear to maxrow()-2,79
      return
    endif
    dirty=.t.
  endif
  if dirty
    @1,0 clear to maxrow()-4,79
  endif
  message;
      " Reindex all index files for all active databases. Are you sure?" query
  @1,0 clear to maxrow()-4,79
  if lastkey()#asc("Y")
    return
  endif
  menu command "REINDEX ALL"
  *set screenmap &screenmap
  set scroll 2,maxrow()-4
  @maxrow()-5,0
  set message to "Reindex in progress, please wait."
  set talk on
  set time on
  on error set time off
  reindex all
  on error
  set talk off
  if .not.set("time")
    msg=message()
    message "&msg.. Press any key to continue."
  else
    set time off
    set message to
    message "Reindex complete, press any key to continue."
  endif
  set scroll 0,maxrow()
  @1,0 clear to maxrow()-2,79
  *set screenmap off
  @maxrow()-2,0
return

*---------------------------------------------------------------------------
* Organise: Pack
*---------------------------------------------------------------------------
proc pack
  if .not.set("exclusive")
    message "This command is not valid with shared databases."
    return
  endif
  if len(m->current_file)=0
    do use
    if len(m->current_file)=0.or.readkey()=ctrl('g')
      return
    endif
  endif
  if ""#bridge()
    message "This facility is not available with bridges."
    return
  endif
  message "Pack all of the active databases. Are you sure?" query
  if lastkey()#asc("Y")
    return
  endif
  menu command "PACK ALL"
  *set screenmap &screenmap
  set scroll 2,maxrow()-4
  @maxrow()-5,0
  set message to "Pack in progress, please wait."
  on error set time off
  set time on
  set talk on
  pack all
  on error
  set talk off
  if .not. set("time")
    msg=message()
    message "&msg.. Press any key to continue."
  else
    set time off
    set message to
    message "Pack complete, press any key to continue."
  endif
  set scroll 0,maxrow()
  @1,0 clear to maxrow()-2,79
  *set screenmap off
  @maxrow()-2,0
return

*---------------------------------------------------------------------------
* Organise: Zap
*---------------------------------------------------------------------------
proc zap
  if .not.set("exclusive")
    message "This command is not valid with shared databases."
    return
  endif
  if len(m->current_file)=0
    do use
    if len(m->current_file)=0.or.readkey()=ctrl('g')
      return
    endif
  endif
  if ""#bridge()
    message "This facility is not available with bridges."
    return
  endif
  message "Zap. Are you sure?" query
  if lastkey()#asc("Y")
    return
  endif
  menu command "ZAP"
  *set screenmap &screenmap
  @maxrow()-4,0
  set message to "Zap in progress, please wait."
  set time on
  on error set time off
  zap
  on error
  if .not.set("time")
    msg=message()
    message "&msg.. Press any key to continue."
  else
    set time off
    set message to
    message "Zap complete, press any key to continue."
  endif
  *set screenmap off
  @maxrow()-2,0
return

*---------------------------------------------------------------------------
* Organise: Copy
*---------------------------------------------------------------------------
proc copy
para filetype
  *------If no database in use select a one using pop-up menu
  if len(m->current_file)=0
    do use
    if len(m->current_file)=0.or.readkey()=ctrl('g')
      return
    endif
  endif
  *------Copy destination file
  menu command "COPY TO"
  fname=space(14)
  dialog get fname;
	 title "SPECIFY A FILE NAME";
         label "Filename:";
         picture "ACCCCCCCCCCCCC";
	 help "Enter the name of the destination file to COPY into."
  if m->fname=' '
    @1,0 clear to maxrow()-2,79
    return
  endif
  fname=trim(fname)
  *------Copy scope menu
  menu command "COPY TO &fname"
  menu scope at 1,0 to 10,33 quit
  if readkey()=ctrl('g')
    @1,0 clear to maxrow()-2,79
    return
  endif
  scope=menuitem()
  if ""#scope
    scope=scope+" "
  endif
  *------Copy fields menu
  lastrow=min(fcount()+6,maxrow()-4)
  menu fields at 1,36 to lastrow,62 select ",";
       command "COPY TO &fname &scope.FIELDS " quit
  if readkey()=ctrl('g')
    @1,0 clear to maxrow()-2,79
    return
  endif
  field_list=menuitem()
  if len(m->field_list)#0
    flist = "FIELDS " + field_list
  else
    flist = ""
  endif
  *------Copy FOR menu       
  @1,0 clear to maxrow()-4,79
  menu query command "COPY TO &fname &scope.&filetype &flist FOR " quit
  if readkey()=ctrl('g')
    @1,0 clear to maxrow()-2,79
    return
  endif
  @1,0 clear to maxrow()-4,79
  for_expression=menuitem()
  set filter to &for_expression
  if ""=for_expression
    menu command "COPY TO &fname &scope.&filetype &flist"
  endif
  *------Copy execution
  set message to "Copy in progress, please wait."
  *set screenmap &screenmap
  set scroll 2,maxrow()-4
  @maxrow()-5,0
  had_error=.f.
  on error had_error=.t.
  set talk on
  copy to &fname &scope &flist &filetype
  set talk off
  on error
  set message to
  if had_error
    msg=message()
    message "&msg.. Press any key to continue."
  else
    message "Copy complete, press any key to continue."
  endif
  set filter to
  set scroll 0,maxrow()
  @maxrow()-5,0 clear to maxrow()-2,79
  *set screenmap off
  @maxrow()-2,0
return

*---------------------------------------------------------------------------
* Organise: total
*---------------------------------------------------------------------------
proc total
  *------If no database in use select a one using pop-up menu
  if len(m->current_file)=0
    do use
    if len(m->current_file)=0.or.readkey()=ctrl('g')
      return
    endif
  endif
  *------total scope menu
  menu command "TOTAL "
  menu scope at 1,0 to 10,33 quit
  if readkey()=ctrl('g')
    @1,0 clear to maxrow()-2,79
    return
  endif
  scope=menuitem()
  if ""#scope
    scope=scope+" "
  endif
  *------total destination file
  @1,0 clear to maxrow()-4,79
  menu command "TOTAL &scope.TO "
  fname=space(14)
  dialog get fname;
	 title "SPECIFY A FILE NAME";
         label "Filename:";
         picture "ACCCCCCCCCCCCC";
	 help "Enter the name of the destination file to TOTAL into."
  if m->fname=' '
    @1,0 clear to maxrow()-2,79
    return
  endif
  fname=trim(m->fname)
  *------total expression
  @1,0 clear to maxrow()-4,79
  lastrow=min(fcount()+6,maxrow()-4)
  menu index fields at 1,0 to lastrow,26;
       command "TOTAL &scope.TO &fname ON " select "+" quit
  if ""=menuitem().or.readkey()=ctrl('g')
    @1,0 clear to maxrow()-2,79
    return
  endif
  expr_list=menuitem()
  *------total FIELDS menu
  @1,0 clear to maxrow()-4,79
  lastrow=min(fcount()+6,maxrow()-4)
  menu fields at 1,0 to lastrow,26;
       command "TOTAL &scope.TO &fname ON &expr_list FIELDS " select "," quit
  if readkey()=ctrl('g')
    @1,0 clear to maxrow()-2,79
    return
  endif
  field_list=menuitem()
  if ""#field_list
    field_list = [FIELDS &field_list ]
  endif
  menu command "TOTAL &scope.&expr_list &field_list.TO "
  *------total FOR menu       
  @1,0 clear to maxrow()-4,79
  menu query command "TOTAL &scope.TO &fname ON &expr_list &field_list.FOR " quit
  if readkey()=ctrl('g')
    @1,0 clear to maxrow()-2,79
    return
  endif
  @1,0 clear to maxrow()-4,79
  for_expression=menuitem()
  set filter to &for_expression
  if ""#m->for_expression
    for_expression="FOR &for_expression"
  endif
  *------total execution
  menu command "TOTAL &scope.TO &fname ON &expr_list &field_list.&for_expression" 
  set message to "Total in progress, please wait."
  *set screenmap &screenmap
  set scroll 2,maxrow()-4
  @maxrow()-5,0
  had_error=.f.
  on error had_error=.t.
  set talk on
  total &scope to &fname on &expr_list &field_list summary
  set talk off
  on error
  set message to
  if had_error
    msg=message()
    message "&msg.. Press any key to continue."
  else
    message "Total complete, press any key to continue."
  endif
  set filter to
  set scroll 0,maxrow()
  @maxrow()-5,0 clear to maxrow()-2,79
  *set screenmap off
  @maxrow()-2,0
return

*---------------------------------------------------------------------------
* Organise: Append
*---------------------------------------------------------------------------
proc appendfrom
para filetype, ext, label
  *------If no database in use select a one using pop-up menu
  if len(m->current_file)=0
    do use
    if len(m->current_file)=0.or.readkey()=ctrl('g')
      return
    endif
  endif
  *------Append FROM file
  menu command "APPEND FROM "
  set message to
  fname=space(14)
  dialog get fname;
	 title "SPECIFY A FILE NAME";
         label "Filename:";
         picture "ACCCCCCCCCCCCC";
	 help "Enter the name of the file to APPEND from."
  if readkey()=ctrl('g')
    @1,0 clear to maxrow()-2,79
    return
  endif
  if m->fname=' '
    @maxrow()-4,0
    lastrow=min(filecount("*.txt")+4,maxrow()-4)
    menu files like *.&ext at 1,0 to lastrow,16 label "&label files" quit trim
    if readkey()=ctrl('g')
      @1,0 clear to maxrow()-2,79
      return
    endif
    fname=menuitem()
    access=.t.
    if "dbf"=m->ext
      area = select()
      sele 10
      on error access=.f.
      use &fname
      on error
      use
      sele &area
    endif
    if .not.m->access
      fname=""
      set message to
      message "You have no permission to access this database."
    endif
    if len(m->fname)=0
      @1,0 clear to maxrow()-2,79
      return
    endif
  endif
  fname=trim(m->fname)
  menu command "APPEND FROM &fname"
  *------Append FOR menu       
  @1,0 clear to maxrow()-4,79
  if len(m->filetype)=0
    ftype="FOR "
  else
    ftype=m->filetype+" FOR"
  endif
  menu query command "APPEND FROM &fname &ftype " quit
  if readkey()=ctrl('g')
    @1,0 clear to maxrow()-2,79
    return
  endif
  @1,0 clear to maxrow()-4,79
  for_expression=menuitem()
  set filter to &for_expression
  if ""=for_expression
    menu command "APPEND FROM &fname &filetype"
  endif
  *------Append execution
  set message to "Append in progress, please wait."
  had_error=.f.
  on error had_error=.t.
  *set screenmap &screenmap
  set scroll 2,maxrow()-4
  @maxrow()-5,0
  set talk on
  append from &fname &filetype
  set talk off
  on error
  set message to
  if had_error
    msg=message()
    message "&msg.. Press any key to continue."
  else
    message "Append complete, press any key to continue."
  endif
  set filter to
  set scroll 0,maxrow()
  @1,0 clear to maxrow()-2,79
  *set screenmap off
  @maxrow()-2,0
  current_format=fmt()
  set format to
return

*---------------------------------------------------------------------------
* Organise: Sort
*---------------------------------------------------------------------------
proc sort
  *------If no database in use select a one using pop-up menu
  if len(m->current_file)=0
    do use 
    if len(m->current_file)=0.or.readkey()=ctrl('g')
      return
    endif
  endif
  if ""#bridge()
    message "This facility is not available with bridges."
    return
  endif
  *------Sort destination file
  menu command "SORT TO"
  fname=space(14)
  dialog get fname;
	 title "SPECIFY A FILE NAME";
         label "Filename:";
         picture "ACCCCCCCCCCCCC";
	 help "Enter the name of the destination file to SORT into."
  if m->fname=' '
    @1,0 clear to maxrow()-2,79
    return
  endif
  fname=trim(m->fname)
  menu command "SORT TO &fname"
  *------Sort scope menu
  menu scope at 1,0 to 10,33 quit
  if readkey()=ctrl('g')
    @1,0 clear to maxrow()-2,79
    return
  endif
  scope=menuitem()
  *------Sort fields menu
  flist = ""
  nore = ""
  forder = .t.
  menu frame at 1,66 to 6,72 label "Order"
  @4,67 say "/a   " color "menus" 
  @5,67 say "/d   " color "menus"
  if ""#scope
    scope=scope+" "
  endif
  do while .t.
     menu command "SORT TO &fname &scope.&flist"
     lastrow=min(fcount()+6,maxrow()-4)
     menu fields at 1,36 to lastrow,62 &nore quit
     if readkey()=ctrl('g')
       @1,0 clear to maxrow()-2,79
       return
     endif
     nore = "norefresh"
     field_list=menuitem()
     if len(m->field_list)#0
       if len(flist)#0
         flist = flist + ","
       endif
       flist = flist + field_list
     else
       if len(m->flist)=0
         @1,0 clear to maxrow()-2,79
         return
       endif
       exit
     endif
     @4,67 menu "/a   " help "Sort this field in ascending order."
     @5,67 menu "/d   " help "Sort this field in descending order."
     menu quit
     if readkey()=ctrl('g')
       @1,0 clear to maxrow()-2,79
       return
     endif
     flist=trim(m->flist)+trim(menuitem())
  enddo
  *------Sort FOR menu       
  @1,0 clear to maxrow()-4,79
  menu query command "SORT &scope.TO &fname ON &flist FOR " quit
  if readkey()=ctrl('g')
    @1,0 clear to maxrow()-2,79
    return
  endif
  @1,0 clear to maxrow()-4,79
  for_expression=menuitem()
  set filter to &for_expression
  if ""=for_expression
    menu command "SORT &scope.TO &fname ON &flist"
  endif
  *------Sort execution
  set message to "Sort in progress, please wait."
  *set screenmap &screenmap
  set scroll 2,maxrow()-4
  @maxrow()-5,0
  had_error=.f.
  on error had_error=.t.
  set talk on
  sort &scope to &fname on &flist 
  set talk off
  on error
  set message to
  if had_error
    message "Command execution error."
  else
    message "Sort complete, press any key to continue."
  endif
  set filter to
  set scroll 0,maxrow()
  @17,0 clear to maxrow()-2,79
  *set screenmap off
  @maxrow()-2,0
return

*===========================================================================
* Main: General
*===========================================================================
proc general
  @0,0
  if iscolor()
    @0,0  say repl(" ", 80) color "menus"
    @0,0  say "General:" color "information"
  else
    @0,0  say bold("General:")
  endif
  @0,9  menu "\<Copy";
	command "do copyfile";
	help "Copy the contents of one file to another.";
	norefresh
  @0,14 menu "\<List";
	command "do dir";
	help "Display disk directory.";
	norefresh
  @0,19 menu "\<Rename";
	command "do rename";
	help "Rename one file to another.";
	norefresh
  @0,26 menu "\<Destroy";
	command "do destroy";
        help "Erase an existing file.";
	norefresh
  @0,34 menu "\<Print";
	command "do print";
        help "Print the contents of a file.";
	norefresh
  @0,40 menu "\<SetColor";
	command "do colors";
        help "Change default screen colors."
  @0,49 menu "\<TimeManager";
       	command "do timemanager";
	help "Activate the time management system."
  @0,61 menu "\<Help";
       	command "Help";
	help "Activate the on-line help system."
  if iscolor()
      @0,69 say ampm() color 'information'
  else 
      @0,69 say reverse(ampm()) color 'information'
  endif
return

*---------------------------------------------------------------------------
* General: TimeManager
*---------------------------------------------------------------------------
proc timemanager
  m_wka = select()
  select(0)
  m_logname = getenv("LOGNAME")
  if (len(m_logname) == 0)
    m_logname = getenv("USERNAME")
  endif
  if (len(m_logname) != 0)
    m_sdb = "file &m_logname"
  else
    m_sdb = ""
  endif
  calendar schedule menu &m_sdb
  select &m_wka
  @1,0 clear to maxrow()-4,79
return

*---------------------------------------------------------------------------
* General: SetColor
*---------------------------------------------------------------------------
proc colors
  set color
  save color to file default.col
  clear
return

*---------------------------------------------------------------------------
* General: Print
*---------------------------------------------------------------------------
proc print
  fname=space(14)
  dialog get fname;
	 title "SPECIFY A FILE NAME";
         label "Filename:";
         picture "ACCCCCCCCCCCCC";
	 help "Enter the name of the file to PRINT or press ^C for a list."
  offset=0
  if readkey()=ctrl('g')
    return
  endif
  if m->fname=' '
    @maxrow()-4,0
    set message to "Select a file. Press ^n for next page, ^g to abandon."
    lastrow=min(filecount("*.txt")+4,maxrow()-4)
    menu files like *.txt at 1,0 to lastrow,16 label "Text files" quit trim
    fname=menuitem()
    if len(m->fname)=0
      @1,0 clear to maxrow()-4,79
      return
    endif
    fname = fname+".txt"
    offset=18
  else
    if at('.',m->fname)=0
      store trim(m->fname)+'.txt' to fname
    endif
  endif
  *------Print destination menu
  menu frame at 1,m->offset to 7,m->offset+12 label "Destination"
  @4,m->offset+1 menu "\<terminal   " help "Display the file on the screen."
  @5,m->offset+1 menu "\<sysprint   " help "Print the file on the system printer."
  @6,m->offset+1 menu "\<print      " help "Print the file on the slave printer."
  menu quit
  if len(menuitem())=0
    @1,0 clear to maxrow()-2,79
    return
  endif
  @1,0 clear to maxrow()-4,79
  *set screenmap &screenmap
  dest=menuitem()
  if dest="sysprint"
    had_error=.f.
    on error had_error=.t.
    menu command "PRINT &fname"
    @maxrow()-4,0
    print &fname
    on error
  else
    @1,0 clear to 7,79
    set scroll 2,maxrow()-4
    if dest="print"
      had_error=.f.
      on error had_error=.t.
      menu command "TYPE &fname TO PRINT"
      @2,0
      type &fname to print
      on error
    else
      had_error=.f.
      on error had_error=.t.
      menu command "TYPE &fname"
      @2,0
      type &fname 
      on error
    endif
  endif
  set message to
  if .not.had_error
    message "Print complete, press any key to continue."
    @1,0 clear to maxrow()-2,79
  else
    msg=message()
    message "&msg.. Press any key to continue."
    @1,0 clear to maxrow()-2,79
  endif
  set scroll 0,maxrow()
  *set screenmap off
  @maxrow()-2,0
return

*===========================================================================
* General: dir
*===========================================================================
proc dir
  menu command "DIR"
  fname=space(14)
  dialog get fname;
	 title "SPECIFY FILE PATTERN";
         label "Filename:";
         picture "XXXXXXXXXXXXXX";
	 help "Enter a file name pattern or press ^W to select all."
  *set screenmap &screenmap
  if readkey()=ctrl('g')
    @maxrow()-2,0
    return
  endif
  menu command "DIR &fname"
  if m->fname=" "
    set scroll 4,maxrow()-4
    @1,0
    dir &fname
    set scroll 0,maxrow()
    @maxrow()-4,0
    set message to
    message "End of directory, press any key to continue."
  else
    set message to "Directory of files. Press ^n for next page, ^g to abandon."
    lastrow=min(filecount("&fname")+4,10)
    menu files like &fname at 1,0 to lastrow,16 label "Files" quit 
  endif
  set message to
  @1,0 clear to maxrow()-2,79
  *set screenmap off
  @maxrow()-2,0
return

*===========================================================================
* General: copyfile
*===========================================================================
proc copyfile
  from_fname=space(14)
  to_fname=space(14)
  menu command "COPY FILE "
  dialog get from_fname;
	 title "SPECIFY FILE NAME";
         label "Filename:";
         picture "XXXXXXXXXXXXXX";
	 help "Enter the name of the file to COPY from or press ^C for a list."
  if readkey()=ctrl('g')
    @maxrow()-2,0
    return
  endif
  if m->from_fname=" ".or."*"$m->from_fname
    if m->from_fname=" "
      from_fname="*.*"
    endif
    @maxrow()-4,0
    set message to "Select a file. Press ^n for next page, ^g to abandon."
    lastrow=min(filecount("&from_fname")+4,10)
    menu files like &from_fname at 1,0 to lastrow,16 label "Files" quit 
    if ""=menuitem()
      @1,0 clear to maxrow()-2,79
      return
    endif
    from_fname=menuitem()
    @1,0 clear to 10,79
    @maxrow()-4,0
  endif
  from_fname=trim(m->from_fname)
  menu command "COPY FILE &from_fname TO "
  dialog get to_fname;
	 title "SPECIFY FILE NAME";
         label "Filename:";
         picture "ACCCCCCCCCCCCC";
	 help "Enter the name of the file to COPY to."
  if m->from_fname=" ".or.m->to_fname=" ".or.readkey()=ctrl('g')
    @1,0 clear to maxrow()-2,79
    set message to
    return
  endif
  from_fname=trim(m->from_fname)
  @maxrow()-4,0
  if .not.file(m->from_fname)
    message "File does not exist, press any key to continue."
    @1,0 clear to maxrow()-2,79
    return
  endif
  menu command "COPY FILE &from_fname TO &to_fname"
  do safety with "&to_fname",""
  if .not.overwrite
    @1,0 clear to maxrow()-2,79
    return
  endif
  set scroll 2,maxrow()-4
  @maxrow()-5,0
  set message to "Copy in progress, please wait."
  had_error=.f.
  on error had_error=.t.
  copy file &from_fname to &to_fname
  on error
  set message to
  if had_error
    msg=message()
    message "&msg.. Press any key to continue."
  endif
  if .not.had_error
    message "Copy complete, press any key to continue."
  endif
  set scroll 0,maxrow()
  @1,0 clear to maxrow()-2,79
return

*===========================================================================
* General: rename
*===========================================================================
proc rename
  from_fname=space(14)
  to_fname=space(14)
  menu command "RENAME "
  dialog get from_fname;
	 title "SPECIFY FILE NAME";
         label "Filename:";
         picture "XXXXXXXXXXXXXX";
	 help "Enter the name of the file to RENAME or press ^C for a list."
  if readkey()=ctrl('g')
    @maxrow()-2,0
    return
  endif
  if m->from_fname=" ".or."*"$m->from_fname
    if m->from_fname=" "
      from_fname="*.*"
    endif
    @maxrow()-4,0
    set message to "Select a file. Press ^n for next page, ^g to abandon."
    lastrow=min(filecount("&from_fname")+4,10)
    menu files like &from_fname at 1,0 to lastrow,16 label "Files" quit 
    if ""=menuitem()
      @1,0 clear to maxrow()-2,79
      return
    endif
    from_fname=menuitem()
    @1,0 clear to 10,79
    @maxrow()-4,0
  endif
  from_fname=trim(m->from_fname)
  menu command "RENAME &from_fname TO "
  dialog get to_fname;
	 title "SPECIFY FILE NAME";
         label "Filename:";
         picture "ACCCCCCCCCCCCC";
	 help "Enter the new name of the file."
  if m->from_fname=" ".or.m->to_fname=" ".or.readkey()=ctrl('g')
    @1,0 clear to maxrow()-2,79
    set message to
    return
  endif
  from_fname=trim(from_fname)
  @maxrow()-4,0
  if .not.file(from_fname)
    message "File does not exist, press any key to continue."
    @1,0 clear to maxrow()-2,79
    return
  endif
  menu command "RENAME &from_fname TO &to_fname"
  set message to
  message "Rename. Are you sure?" query
  if lastkey()#asc("Y")
    @1,0 clear to maxrow()-2,79
    return
  endif
  set message to
  do safety with "&to_fname",""
  if .not.overwrite
    @1,0 clear to maxrow()-2,79
    return
  endif
  @maxrow()-4,0
  had_error=.f.
  on error had_error=.t.
  rename &from_fname to &to_fname
  on error
  set message to
  if had_error
    msg=message()
    message "&msg.. Press any key to continue."
  endif
  @1,0 clear to maxrow()-2,79
return

*===========================================================================
* General: destroy
*===========================================================================
proc destroy
  fname=space(14)
  menu command "ERASE"
  dialog get fname;
	 title "SPECIFY FILE NAME";
         label "Filename:";
         picture "XXXXXXXXXXXXXX";
	 help "Enter the name of the file to ERASE or press ^C for a list."
  if readkey()=ctrl('g')
    @maxrow()-2,0
    return
  endif
  filename=m->fname
  lastrow=0
  do while .t.
    had_file=.t.
    if m->filename=" ".or."*"$m->filename
      had_file=.f.
      if m->filename=" "
        filename="*.*"
      endif
      @maxrow()-4,0
      set message to "Select a file. Press ^n for next page, ^g to abandon."
      if lastrow=0
        lastrow=min(filecount("&filename")+4,10)
      endif
      menu files like &filename at 1,0 to lastrow,16;
	   label "Files" quit clear
      if ""=menuitem()
        @1,0 clear to maxrow()-2,79
        set message to
        return
      endif
      fname=menuitem()
    endif
    fname=trim(m->fname)
    if .not. file(m->fname)
      message "File does not exist, press any key to continue."
      @1,0 clear to maxrow()-2,79
      return
    endif
    menu command "ERASE &fname"
    set message to
    message "Erase. Are you sure?" query
    if lastkey()#asc("Y")
      @1,0 clear to maxrow()-2,79
      return
    endif
    set message to
    had_error=.f.
    on error had_error=.t.
    erase &fname
    on error
    @maxrow()-4,0
    set message to
    if had_error
      msg=message()
      message "&msg.. Press any key to continue."
    endif
    if had_file
      exit
    endif
    fname=space(14)
  enddo
  @1,0 clear to maxrow()-2,79
return

*===========================================================================
* Main: Use
*===========================================================================
proc use
  close databases
  set message to "Select a database from the list. Use ^g to abandon."
  lastrow=min(filecount("*.dbf")+4,maxrow()-4)
  menu files like *.dbf at 1,0 to lastrow,16 label "Databases" quit trim
  current_format=""
  current_file=menuitem()
  access=.t.
  on error access=.f.
  use &current_file
  select 1
  err=error()
  on error
  if .not.m->access
    current_file=""
    msg=message()
    close data
    message "&msg.. Press any key to continue."
  endif
  if len(current_file)=0
    @1,0 clear to 20,79
    return
  endif
  current_format=fmt()
  set format to
  if ""#ndx(1).or.""#dbf(2)
    @1,0 clear to 20,79
    return
  endif
  lastrow=min(ifilecount("*.ndx")+4,maxrow()-4)
  set message to "Select index files;
from the list. Use ^w to exit, ^g to abandon."
  menu index files like *.ndx at 1,18 to lastrow,34 select ",";
       label "Indexes" quit trim
  @1,0 clear to maxrow()-4,79
  idx=menuitem()
  set index to &idx  
return

*===========================================================================
* Main: Usedbf
*===========================================================================
proc usedbf
  set message to "Select a database from the list. Use ^g to abandon."
  lastrow=min(filecount("*.dbf")+4,maxrow()-4)
  menu files like *.dbf at 1,0 to lastrow,16 label "Databases" quit trim
  current_format=""
  current_file=menuitem()
  access=.t.
  on error access=.f.
  use &current_file
  select 1
  err=error()
  on error
  if .not.m->access
    current_file=""
    msg=message()
    close data
    message "&msg.. Press any key to continue."
  endif
  current_format=fmt()
  set format to
  @1,0 clear to 20,79
return

*===========================================================================
* Main: Bridges
*===========================================================================
proc bridges
  @0,0
  if iscolor()
    @0,0  say repl(" ", 80) color "menus"
    @0,0  say "Bridges:" color "information"
  else
    @0,0  say bold("Bridges:")
  endif
  @0,9  menu "\<Bridge";
	command "do setupbridge";
	help "Bridge to foreign files and views."
  @0,16 menu "\<2020";
	command "do bridge2020";
	help "Import and Export files in 2020 spreadsheet interface format."
  @0,21 menu "\<Wp";
	command "do bridgewp";
	help "Import and Export files in wordprocessor text format."
  @0,24 menu "\<Delimited";
	command "do bridgedeli";
	help "Import and Export files in delimited text format."
  @0,34 menu "\<Fixed";
	command "do bridgefixed";
	help "Import and Export files in binary format."
  @0,40 menu "\<Use";
	command "do use;@maxrow()-2,0";
	help "Select a database for further operations."
  @0,44 menu "\<Help";
       	command "Help";
	help "Activate the on-line help system."
  if iscolor()
      @0,69 say ampm() color 'information'
  else 
      @0,69 say reverse(ampm()) color 'information'
  endif
return

*---------------------------------------------------------------------------
* Bridges: 2020
*---------------------------------------------------------------------------
proc bridge2020
  menu format r2020_menu quit helpfile 'help'
  vtype=menu()
  if m->vtype<0
    return
  elseif m->vtype=0
    do appendfrom with [TYPE 2020],[txt],[2020]
  else
    do copy with [TYPE 2020]
  endif
return

*---------------------------------------------------------------------------
* Bridges: Wp
*---------------------------------------------------------------------------
proc bridgewp
  menu format rwp_menu quit helpfile 'help'
  vtype=menu()
  if m->vtype<0
    return
  elseif m->vtype=0
    do appendfrom with [TYPE SDF],[txt],[Wp]
  else
    do copy with [TYPE SDF]
  endif
return

*---------------------------------------------------------------------------
* Bridges: delimited
*---------------------------------------------------------------------------
proc bridgedeli
  menu format rdeli_menu quit helpfile 'help'
  vtype=menu()
  if m->vtype<0
    return
  elseif m->vtype=0
    do appendfrom with [TYPE DELIMITED],[txt],[Delimited]
  else
    do copy with [TYPE DELIMITED]
  endif
return

*---------------------------------------------------------------------------
* Bridges: fixed
*---------------------------------------------------------------------------
proc bridgefixed
  menu format rfixed_menu quit helpfile 'help'
  vtype=menu()
  if m->vtype<0
    return
  elseif m->vtype=0
    do appendfrom with [TYPE FIXED],[txt],[Fixed]
  else
    do copy with [TYPE FIXED]
  endif
return

*---------------------------------------------------------------------------
* Bridges: 
*---------------------------------------------------------------------------
proc setupbridge
  menu format rbridge_menu quit helpfile 'help'
  vtype=menu()
  if m->vtype<0
    return
  endif
  if m->vtype=3
    close databases
    select a
    return
  endif
  fname=space(14)    
  dialog get fname;
	 title "SPECIFY FILE NAME";
         label "Filename:";
         picture "ACCCCCCCCCCCCC";
	 help "Enter the name of the BRIDGE file or press ^C for a list."
  if readkey()=ctrl('g')
    return
  endif
  if m->fname=' '
    if m->vtype=1
      close all
      return
    endif
    @maxrow()-4,0
    set message to "Select a bridge from the list. Use ^g to abandon."
    lastrow=min(filecount("*.brg")+4,maxrow()-4)
    menu files like *.brg at 1,0 to lastrow,16 label "Bridges" quit trim
    @1,0 clear to maxrow()-4,79
    current_format=""
    fname=menuitem()
    if len(m->fname)=0
      close all
      current_file=""
      return
    endif
  endif
  if m->vtype=0
    store trim(m->fname) to fname
    if at('.',m->fname)=0
      store m->fname+'.brg' to fname
    endif
    if .not.file(m->fname)
      message "Bridge does not exist. Press any key to continue."
      return
    endif      
    @maxrow()-4,0
    set message to "Establishing bridge &fname, please wait."
    had_error=.f.
    on error had_error=.t.
    use &fname
    on error
    if had_error
      msg=message()
      message "&msg.. Press any key to continue."
    endif
    current_file=upper(dbf())
  else
    if m->vtype=1
      do safety with "&fname",".brg"
      if .not.overwrite
        return
      endif
      had_error=.f.
      on error had_error=.t.
      *set screenmap &screenmap
      create bridge &fname
      *set screenmap off
      on error
      if had_error
	msg=message()
	message "&msg.. Press any key to continue."
      endif
    else
      had_error=.f.
      on error had_error=.t.
      *set screenmap &screenmap
      modify bridge &fname
      *set screenmap off
      on error
      if had_error
	msg=message()
	message "&msg.. Press any key to continue."
      endif
    endif
  endif
  current_format=fmt()
  set format to
return

proc rdeli_menu
  @0,0
  if iscolor()
    @0,0  say repl(" ", 80) color "menus"
    @0,0  say "Delimited:" color "information"
  else
    @0,0  say bold("Delimited:")
  endif
  @0,11 menu "\<Import";
	help "Import from a file in delimited text format."
  @0,18 menu "\<Export";
	help "Export to a file in delimited text format."
  @0,25 menu "\<Use";
	command "do use;@maxrow()-2,0";
	help "Select a database for further operations."
  @0,29 menu "\<Help";
       	command "Help";
	help "Activate the on-line help system."
  if iscolor()
      @0,69 say ampm() color 'information'
  else 
      @0,69 say reverse(ampm()) color 'information'
  endif
return

proc rwp_menu
  @0,0
  if iscolor()
    @0,0  say repl(" ", 80) color "menus"
    @0,0  say "Wp:" color "information"
  else
    @0,0  say bold("Wp:")
  endif
  @0,4  menu "\<Import";
	help "Import from a file in wordprocessor text format."
  @0,11 menu "\<Export";
	help "Export to a file in wordprocessor text format."
  @0,18 menu "\<Use";
	command "do use;@maxrow()-2,0";
	help "Select a database for further operations."
  @0,22 menu "\<Help";
       	command "Help";
	help "Activate the on-line help system."
  if iscolor()
      @0,69 say ampm() color 'information'
  else 
      @0,69 say reverse(ampm()) color 'information'
  endif
return

proc rfixed_menu
  @0,0
  if iscolor()
    @0,0  say repl(" ", 80) color "menus"
    @0,0  say "Fixed:" color "information"
  else
    @0,0  say bold("Fixed:")
  endif
  @0,7  menu "\<Import";
	help "Import from a file in fixed binary format."
  @0,14 menu "\<Export";
	help "Export to a file in fixed binary format."
  @0,21 menu "\<Use";
	command "do use;@maxrow()-2,0";
	help "Select a database for further operations."
  @0,25 menu "\<Help";
       	command "Help";
	help "Activate the on-line help system."
  if iscolor()
      @0,69 say ampm() color 'information'
  else 
      @0,69 say reverse(ampm()) color 'information'
  endif
return

proc r2020_menu
  @0,0
  if iscolor()
    @0,0  say repl(" ", 80) color "menus"
    @0,0  say "2020:" color "information"
  else
    @0,0  say bold("2020:")
  endif
  @0,6  menu "\<Import";
	help "Import from a file in 2020 spreadsheet interface format."
  @0,13 menu "\<Export";
	help "Export to a file in 2020 spreadsheet interface format."
  @0,20 menu "\<Use";
	command "do use;@maxrow()-2,0";
	help "Select a database for further operations."
  @0,24 menu "\<Help";
       	command "Help";
	help "Activate the on-line help system."
  if iscolor()
      @0,69 say ampm() color 'information'
  else 
      @0,69 say reverse(ampm()) color 'information'
  endif
return

proc rbridge_menu
  @0,0
  if iscolor()
    @0,0  say repl(" ", 80) color "menus"
    @0,0  say "Bridge:" color "information"
  else
    @0,0  say bold("Bridge:")
  endif
  @0,8  menu "\<Select";
	help "Connect an existing bridge."
  @0,15 menu "\<Create";
	help "Create a new bridge."
  @0,22 menu "\<Modify";
	help "Modify an existing bridge."
  @0,29 menu "\<Deselect";
	help "Disconnect the current bridge."
  @0,38 menu "\<Help";
       	command "Help";
	help "Activate the on-line help system."
  if iscolor()
      @0,69 say ampm() color 'information'
  else 
      @0,69 say reverse(ampm()) color 'information'
  endif
return

proc safety
para fname,ftype
priv f
  f=trim(m->fname)+m->ftype
  if file(m->f).and.m_safety
    set message to
    message "File &f already exists, overwrite it?" query
    if lastkey()=asc("Y")
      erase &f
      overwrite=.t.
    else
      overwrite=.f.
    endif
  else
    overwrite=.t.
  endif
return

proc escape
  set escape off
  on escape
  set message to
  message "Are you sure you want to abandon the operation?" query
  if lastkey()=asc("Y")
    cancel=.t.
  else
    set escape on
    on escape do escape
  endif
return

*===========================================================================
* Function key menu.
*===========================================================================
* Popup layout of keyboard
proc helpkeys
  declare keytab[13]
  declare keydes[13]
  keytab[1]="/";  keydes[1]="Activate MenuBar"
  keytab[2]="^c"; keydes[2]="Field Choicelist"
  keytab[3]="^n"; keydes[3]="Next Record"
  keytab[4]="^r"; keydes[4]="Previous Record"
  keytab[5]="^k"; keydes[5]="Find Record"
  keytab[6]="^l"; keydes[6]="Find Next Record"
  keytab[7]="^y"; keydes[7]="Erase Field"
  keytab[8]="^u"; keydes[8]="Delete Record"
  keytab[9]="^t"; keydes[9]="Update Mode"
  keytab[10]="^d";keydes[10]="Refresh Screen"
  keytab[11]="^w";keydes[11]="Exit Saving Changes"
  keytab[12]="^g";keydes[12]="Quit discarding changes"
  keytab[13]="^v";keydes[13]="Edit a field"
  save screen
  set fklabel on
  @3,25 to maxrow()-4,58 label "Function key usage" bold
  for i=1 to 13
    @i+5,26 say keytab[i]
    @i+5,35 say keydes[i]
  next
  message "Press any key to return into the form."
  set fklabel off
  restore screen
  noexit
return

*===========================================================================
* Main program
*===========================================================================
close data
clear
screenmap=iif(set("screenmap"),"ON","OFF")
*set screenmap off
current_format=""
current_file=""
field_list=""
for_expression=""
overwrite=.f.
alias fkhelp "do helpkeys"
do while .t.
  menu format main save quit helpfile "help"
  message "Do you really want to exit the Assistant?" query
  if lastkey()=asc("Y")
    exit
  endif
enddo
if ""#dbf()
  @maxrow(),0
  set message to "Closing your databases. Please wait."
endif
set clock off
close data
clear menu
*set screenmap &screenmap
set hist (m_history)
set pckeys (m_pckeys)
set safety (m_safety)
set lock (m_lock)
set assist off
clear
